/*
 * Accelerometer.h
 *
 *
 *      Author: Cesar López
 *		Last Update: 31/12/2016
 */

#ifndef ACCELEROMETER_H_
#define ACCELEROMETER_H_

#define mNUMREAD 100
#define PI 3.141592

#include "adc.h"

/*
 *
 *
 *
 * Limit time for alarm rise
 *
 */

#define mMILIS_FALLING 8000
#define mMILIS_INAC    15000

/*
 *
 *
 *
 * Cycle of monitoring
 *
 */

#define mTIME_MONIT  60000

/*
 *
 *
 *
 *
 * Data signal from accelerometer module
 *
 */

#define mDATA_ACCEL 101


/*
 *
 *
 *
 *
 * Prototypes of public methods
 *
 */


/** Set GPIO and select resolution for accelerometer
 *
 *  @param void
 *
 *  @return void
 *
 */


void Accel_vInit(void);


/** Calculate G-Forces and angles from sRData raw reads.
 *
 *  @param sRData data structure with raw data from ADC(sended from APP main)
 *
 *
 *  @return void
 */


void Accel_sRAccel ( sReadAccel *sRData );


#endif /* ACCELEROMETER_H_ */
