/*
 * Accelerometer.c
 *
 *
 *      Author: Cesar López
 *
 */

#ifndef ADC_H_
#define ADC_H_


/*
 *
 *
 *
 * Structure for data, is useful for adc and accelerometer
 *
 */

typedef struct {
	uint32_t fX;
	uint32_t fY;
	uint32_t fZ;
	float fpX;
	float fpY;
	float fpZ;
	float faX;
	float faY;
	float faZ;
} sReadAccel;

/*
 *
 *
 *
 *
 *
 *
 * Methods Prototypes
 *
 *
 *
 */

/** Prepare ADC. Set PCONP and configure operation mode in ADCR
 *
 *  @param uint32_t Clk
 *  @param int iPos: position in the array of the current alarm
 *
 */


void ADC_vADCInit( uint32_t ADC_Clk );


/** Read the selected channel from ADC
 *
 * @param void
 *
 * @return value read
 */


uint32_t ADC_Read( uint8_t channelNum );


/** Read 3 lower channels(300) and calculate average
 *
 * @param void
 *
 * @return void
 */

void ADC_ADCAverage(sReadAccel *sAData );

#endif /* ADC_H_ */
