/*
 * gpio.h
 *
 *  Created on: Jan 25, 2016
 *      Author: jordi
 */

#ifndef GPIO_H_
#define GPIO_H_

#include "LPC17xx.h"
#include "stdint.h"

#define GPIO_LOW 0
#define GPIO_HIGH 1



typedef enum gpio_mode_operations{
	GPIO_OUT,
	GPIO_IN,
	// add all modes
} gpio_mode_operation;


typedef enum gipo_errors{
	GPIO_NON_ERROR,
	GPIO_ERROR_NOT_SUPPORTED
} gipo_error;


// todo:jbec: support all ports
// todo:jbec: support all modes
/**
 * Config pad (defined by Pport.pin) to speific mode
 *
 * @param pad	Pad identifier. Pad is port*32 + bit, e.g.: pad 35, is port 1 bit 3, pad 17 is port 0 bit 17, ... (only supported 0 and 1)
 * @param mode	Mode operation (GPIO_OUT, GPIO_IN, ...)
 */
gipo_error Gpio_config(uint8_t pad, gpio_mode_operation mode);

/**
 * Set value val in GPIO.
 *
 * @param pad 	pad number
 * @param val	GPIO_LOW or GPIO_HIGH
 */
void Gpio_set(uint8_t pad, uint8_t val);



#endif /* GPIO_H_ */
