/*
 * log.h
 *
 *  Created on: Nov 9, 2016
 *      Author: jordi
 *
 *
 *      Modified: by César López
 */

#ifndef LOG_H_
#define LOG_H_

#include "serial.h"

/*
 *
 *
 *
 *
 * Define Uart for log
 *
 */

#define mUART_LOG	   (SERIAL_PORT3)

/*
 *
 *
 *
 *
 * Define Filters for Log. mMAXFI is the number of total filters
 *
 */

#define mGENER 0
#define mACCEL 1
#define mPULSO 2
#define mTHERM 3
#define mANALO 4
#define mCOMMU 5
#define mMAXFI 6


/*
 *
 *
 *
 *
 *
 *
 * Methods Prototypes
 *
 *
 *
 */

/*
 * Start log module
 *
 * @param	port		UART port used to send log data
 * @param	baudRate	port speed
 *
 * @return TRUE if SUCCESS, otherwise false
 */
uint_fast8_t Log_start( uint_fast8_t port, serial_baudrate baudRate );


/*
 * Print log text
 *
 * @param iFilter Filter to check if text has to be displayed or not
 * @param format 	like printf of cstdio C standard
 *
 * @return len of buffer_tx
 */

uint_fast16_t Log_print(uint_fast8_t iFilter, char* format, ...);

/** Read a user command from mUART_LOG and do it
 *
 * @param void
 *
 * @return void
 */

void Log_vReadLogCmd();


/** Print menu options in screen
 *
 * @param void
 * @param void
 *
 * @return void
 */

void Log_vPrintMenu();

#endif /* LOG_H_ */
