/*
 * serial.h
 *
 *  Created on: Feb 4, 2016
 *      Author: jordi
 */

#ifndef SERIAL_H_
#define SERIAL_H_

#include "uart.h"
#include <stdarg.h>

#define SERIAL_TX_BUFFER		1000
#define SERIAL_RX_BUFFER		1000


#define SERIAL_PORT0	UART_PORT0
#define SERIAL_PORT1	UART_PORT1
#define SERIAL_PORT2	UART_PORT2
#define SERIAL_PORT3	UART_PORT3
#define SERIAL_MAX_PORT	4




typedef enum serial_baudrates {
	BAUD_9600			= 9600,
	BAUD_19200			= 19200,
	BAUD_57600			= 57600,
	BAUD_115200			= 115200,
	BAUD_UNSUPORTED		= 0,
} serial_baudrate;


/* Initialize serial port
 *
 * @param port Serial port to use
 * @param baudrate to use
 *
 * @return TRUE if all ok, othewise FALSE
 */
uint_fast8_t Serial_start( uint_fast8_t port, serial_baudrate baudRate );


/*
 * Send data via serial port
 *
 * @param port 		uart port to send data
 * @param format 	like printf of cstdio C standard
 */
uint_fast16_t Serial_send(uint_fast8_t port, char * format, ...);

/*
 *
 * @param port 		uart port to send data
 * @param format  	string that contains a format string that follows the same specifications as format in Serial_send
 */
uint_fast16_t Serial_vsend(uint_fast8_t port, char *format, va_list args);


#endif /* SERIAL_H_ */
