/*****************************************************************************
 *   type.h:  Type definition Header file for NXP LPC17xx Family 
 *   Microprocessors
 *
 *   Copyright(C) 2009, NXP Semiconductor
 *   All rights reserved.
 *
 *   History
 *   2009.05.25  ver 1.00    Prelimnary version, first Release
 *
******************************************************************************/
#include <stdint.h>
#include "stdbool.h"

#ifndef __TYPE_H__
#define __TYPE_H__

#ifndef NULL
#define NULL    ((void *)0)
#endif

#ifndef FALSE
#define FALSE   ((uint8_t) 0)
#endif

#ifndef TRUE
#define TRUE    ((uint8_t) 1)
#endif

/*
 *
 *
 *
 *
 *
 *Structure of a queue item
 *
 */


typedef struct
{
    bool bIsON;
    uint16_t iValue;
    uint8_t  iParam;
    uint8_t iTry;
	uint8_t iOPT;
    char *cTime;
} sSendAlarm;

typedef enum {RESET = 0, SET = !RESET} FlagStatus, ITStatus;
typedef enum {DISABLE = 0, ENABLE = !DISABLE} FunctionalState;

#endif  /* __TYPE_H__ */
