/*
 * Pulse.c
 *
 *  Created on: 23 de dic. de 2016
 *  Author: Cesar López
 */

#include "assertlib.h"
#include "type.h"
#include "FreeRTOS.h"
#include "stdbool.h"
#include "config.h"
#include "Pulse.h"
#include "task.h"
#include "log.h"
#include "Pulse.h"
#include "gpio.h"


/*
 * ----------------------------------------
 * ----------- PUBLIC METHODS --------------
 * ----------------------------------------
 */


/** Configure GPIO p0[8] for Shutdown pin of the pulsometer
 *
 * @param void
 *
 * @return void
 */


void Pulse_vInit()
{
	Gpio_config(PULSE_SHTDWN, GPIO_OUT);
	Gpio_set(PULSE_SHTDWN, GPIO_LOW);
}


/** Power on or off the pulsometer
 *
 * @param bSet true means power on.
 *
 * @return void
 */


void Pulse_Activate(bool bSet)
{
	if(bSet==true)
	{
		Log_print(mPULSO,"mPULSE says:Activated pulsometer\r\n");
		Gpio_set(PULSE_SHTDWN, GPIO_HIGH);
	}
	else
	{
		Log_print(mPULSO,"mPULSE says:Activated pulsometer\r\n");
		Gpio_set(PULSE_SHTDWN, GPIO_LOW);
	}
}
