/*
 * gpio.c
 *
 *  Created on: Jan 25, 2016
 *      Author: jordi
 *
 *
 *      Modified by: Cesar López
 *
 */

#include "gpio.h"

#include "assertlib.h"


#define GPIO_PORT0	0
#define GPIO_PORT1	1		// NOT SUPPORTED YET
#define GPIO_PORT2	2		// NOT SUPPORTED YET
#define GPIO_PORT3	3		// NOT SUPPORTED YET


//cLop Added GPIO_IN mode for port 0: todo:jbec: Create method to configure other options (more than GPIO);

gipo_error Gpio_config(uint8_t pad, gpio_mode_operation mode ) {

	uint8_t port;
	uint8_t pin;

	port = pad / 32;
	pin = pad % 32;



			switch(port)
			{
			// It needs to modify 2 bits to config 1 pin ==> pin 0: bit 1 and 0, pin 1: bits 3 and 2, ...
			case GPIO_PORT0:
			{
				if (pin <= 15) {		// controled by register 0
					LPC_PINCON->PINSEL0	&= ~((3)<<(pin<<1));
					LPC_PINCON->PINMODE0|= ((3)<<(pin<<1));

					if (mode == GPIO_OUT)
					{
						LPC_GPIO0->FIODIR |= (1<<pin);     //Set as GPIO for output
					}
					else
					{
						LPC_GPIO0->FIODIR &= ~(1<<pin);	//Set as GPIO for input
					}

				} else if (pin > 15){	// controled by register 1

					LPC_PINCON->PINSEL1	&= ~((3)<<(pin<<1));
					LPC_PINCON->PINMODE1|= ((3)<<(pin<<1));
					if (mode == GPIO_OUT)
					{
					LPC_GPIO0->FIODIR |= (1<<pin); //Set as GPIO for output
					}
					else
					{
						LPC_GPIO0->FIODIR &= ~(1<<pin);	//Set as GPIO for input
					}

				}else{
					return 0;
				}
				break;
			}

			case 1:
			{	// TODO test
				if(pin <= 15){		// controled by register 2
					LPC_PINCON->PINSEL2		&= ~((3)<<(pin<<1));
					LPC_PINCON->PINMODE2	|= ((3)<<(pin<<1));
					LPC_GPIO1->FIODIR 		|= (1<<pin);
				}else if(pin > 15){	// controled by register 3
					LPC_PINCON->PINSEL3	&= ~((3)<<(pin<<1));
					LPC_PINCON->PINMODE3	|= ((3)<<(pin<<1));
					LPC_GPIO1->FIODIR 		|= (1<<pin);
				}else{
					return 0;
				}

				break;
			}
			default:
				assert(0);
				return GPIO_ERROR_NOT_SUPPORTED;

	}

	return GPIO_NON_ERROR;
}

void Gpio_set(uint8_t pad, uint8_t val) {
	uint8_t port;
	uint8_t pin;

	port = pad / 32;
	pin = pad % 32;

	switch (port) {
			case GPIO_PORT0:
				if(pin <= 31){
					if (GPIO_LOW == val) {
						LPC_GPIO0->FIOCLR = 1 << pin;		// put 0
					}else{
						LPC_GPIO0->FIOSET = 1 << pin;		// put 1
					}

				} else {
					assert(0);
				}
				break;

			case GPIO_PORT1:
				if(pin <= 31){
					if (GPIO_LOW == val) {
						LPC_GPIO1->FIOCLR = 1 << pin;		// put 0
					}else{
						LPC_GPIO1->FIOSET = 1 << pin;		// put 1
					}

				} else {
					assert(0);
				}
				break;

			default:
				;
				assert(0);
				break;
		}

}


