/*
 * led.c
 *
 *  Created by : César López
 *  Last Update 03/02/2017
 */


#include "LPC17xx.h"
#include "log.h"
#include "FreeRTOS.h"
#include "led.h"
#include "gpio.h"
#include "stdbool.h"

/*
 * ----------------------------------------
 * ----------- PUBLIC METHODS --------------
 * ----------------------------------------
 */

/** Init GPIO for LED
 *
 * @param void
 *
 * @return void
 */

void Led_init(void)
{
	Gpio_config(LED_PAD, GPIO_OUT);
	Gpio_set(LED_PAD, GPIO_LOW);
}

/** Set led state high or low.
 *
 * @param bool   true means HIGH and false means LOW
 *
 * @return void
 */

void Led_SetOrClr( bool bLevel)
{
			if(bLevel) Gpio_set(LED_PAD, GPIO_HIGH);
			else Gpio_set(LED_PAD, GPIO_LOW);
}
