/*
 * utils.c
 *
 *  Created on: Feb 15, 2016
 *      Author: jordi
 *
 *
 *    Modified by: César López
 *    Last Update: 30/12/2016
 *
 */


//https://www.lpcware.com/content/forum/compiler-option-o0-o1-o2-os-debug-mode

#include "utils.h"
#include "serial.h"
#include <stdint.h>
#include "LPC17xx.h"
#include <string.h>
#include "log.h"
#include "config.h"
#include "FreeRTOS.h"
#include "uart.h"
#include "semphr.h"

#define IAP_ADDRESS 0x1FFF1FF1

/*
 * Local variables
 */

unsigned Parameter[5];
unsigned Result[5];


/*
 * ----------------------------------------
 * ----------- LOCAL METHODS --------------
 * ----------------------------------------
 */

/** Access IAP to get the serial number of the device
 *
 * @param param_tab[]
 *
 * @param result_tab[]
 *
 * @returns void
 */

static void _Iap(unsigned param_tab[],unsigned result_tab[])
{
   void (*iap)(unsigned [],unsigned []);

   iap = (void (*)(unsigned [],unsigned []))IAP_ADDRESS;
   iap(param_tab,result_tab);
}


/*
 * ----------------------------------------
 * ----------- PUBLIC METHODS --------------
 * ----------------------------------------
 */


/**
 * Delay (using Busy waiting method)
 *
 * @param ms	time to wait in miliseconds
 *
 * @returns void
 */

__attribute__((optimize("O0"))) void Utils_delayMs(uint32_t ms) {
	int i;

	for(i=0; i<( ((uint32_t)7140)*ms); i++){
		;
	}
}


/**
 * Read the serial number of the device
 *
 * @param *uRx[5] Array to get the ID of the LPC1769.
 *
 * @returns void
 */

void Utils_ReadSerialNumber(unsigned *uRx[5])
{
	Parameter[0] = 58;
	_Iap(Parameter,Result);
	uRx[1] = Result[1];
	uRx[2] = Result[2];
	uRx[3] = Result[3];
	uRx[4] = Result[4];
}

